﻿#!/bin/sh

#Script name: procss.sh
#Support MOTOZINE ZN5
#Write by: drunia 


TMP_PROC_FILE="/tmp/.processes"

#########################STR_VARS#########################
STR_CAPTION="Процессы"
STR_HINT="Выберите процесс:"
STR_HINT_GETPROC="Выберите, что делать с процессом:"
STR_KILL="Убить"
STR_STOP="Приостановить"
STR_RESUME="Возобновить"
STR_COMPLETE_OK="завершенно успешно"
STR_COMPLETE_FAIL="потерпело неудачу"
STR_KILL_OP="Операция убить"
STR_STOP_OP="Операция приостановить"
STR_RESUME_OP="Операция возобновить"
##########################################################

get_proc()
{
	[ $? -ne 0 ] || exit 1
	SEL_PROC=$1
	for PROC in $ALLPROCS; do
		let "j = j + 1"
		if [ "$j" -eq $SEL_PROC ]; then
			break
		fi
	done
	showRadio "$STR_CAPTION" "$STR_HINT_GETPROC \"$PROC\"" "$STR_KILL" "$STR_STOP" "$STR_RESUME"
	case $? in
		1 ) OP="$STR_KILL_OP \"$PROC\""	
		    busybox killall -9 $PROC
		    ;;
		2 ) OP="$STR_STOP_OP \"$PROC\""
                    busybox killall -19 $PROC
		    ;;
		3 ) OP="$STR_RESUME_OP \"$PROC\""
		    busybox killall -18 $PROC
		    ;;
		* ) sh "$0" &
		    exit 1
		    ;;
	esac
	return $?
}

make_proc_list()
{
	 showNotify "$STR_CAPTION" "Строю список, ждите..." 1 1
	 fuser -v "/" 1 >/dev/null 2>"$TMP_PROC_FILE"
	 cat "$TMP_PROC_FILE" | awk '{print $3}' | \
	 sed -e "/.[\/\?]./d /\../d /ACCESS/d /\../d" | \
	 busybox sort >"$TMP_PROC_FILE"
	 ALLPROCS=`cat "$TMP_PROC_FILE"`
	 for i in $ALLPROCS; do
		if [ "$j" != "$i" ]; then
			TMP_ALLPROCS="$TMP_ALLPROCS $i"
			j=$i
	        fi
	 done
	 if [ -z "$TMP_ALLPROCS" ]; then
		sh "$0" &
		exit 1
	 else
	 	ALLPROCS="$TMP_ALLPROCS"
	 fi
	 unset i
	 unset j
	 unset TMP_ALLPROCS
	 return 0
}

#begin
make_proc_list
showRadio "$STR_CAPTION" "$STR_HINT" $ALLPROCS
get_proc $?


if [ $? -eq 0 ]; then
	showNotify "$STR_CAPTION" "$OP $STR_COMPLETE_OK" 1 3
	sh "$0" &
else
	showNotify "$STR_CAPTION" "$OP $STR_COMPLETE_FAIL" 1 3
	sh "$0" &
fi


exit 0
